
/* Constants */

var FILE_BOOT_STRAP = "bootstrap.wsf";

/* Models */

function LauncherClass(){
	
}
LauncherClass.prototype = {
	base : null,
	resolved : null,
	traits : null,
	path : {
		app : null,
		profile : null
	}
}

/* Implements */

CluCoreObject = new function(){
	var cmdListMap = new Object();
	var profMap = new Object();
	var classLoaded = false;
	
	this.addLauncherTraits = function( name, lnch ){
		cmdListMap[ name ] = lnch;
	}
//	this.getLauncherTraits = function( name ){
//		return cmdListMap[ name ];
//	}
	this.removeLauncherTraits = function( name ){
		delete cmdListMap[ name ];
	}
	this.loadCommandList = function( alias, cmdlist ){
		if( ! cmdlist ){
			cmdlist = new Array();
		}
		var clazz = this.getClass( alias );
		var command = cmdListMap[ clazz.traits ];
		if( !command ){
			WScript.echo("G[: W[ "+ clazz.traits +" ܂");
			WScript.quit();
		}
		command.loadCommandList( clazz, cmdlist );
		return cmdlist;
	}
	this.saveCommandList = function( alias, cmdlist ){
		var clazz = this.getClass( alias );
		cmdListMap[ clazz.traits ].saveCommandList( clazz, cmdlist );
	}
	
	this.loadClasses = function(){
		var prof;
		read_lines("classdef.ini", function( line ){
			if( ! line.match(/^\s*;/) ){
				if( line.match(/^\s*\[(\w+(?:\:\w+)?)\]\s*$/) ){
					var section = RegExp.$1;
					var name = section;
					prof = new Object();
					if( section.match(/(\w+):(\w+)/) ){
						name = RegExp.$1;
						prof.base = RegExp.$2;
					}
					profMap[ name ] = prof;
				}else if( line.match(/^\s*([\w\.]+)\s*=\s*(.*)\s*$/) ){
					var fullkey = RegExp.$1;
					var value = RegExp.$2.replace(/\"((?:\\\"|[^\"])*)\"/,"$1");
					var box = prof;
					var keyfrags = fullkey.split(/\./g);
					var key = keyfrags.pop();
					foreach( keyfrags, function( frag ){
						if( box[ frag ] == undefined ){
							box[ frag ] = new Object();
						}
						box = box[ frag ];
					} );
					box[ key ] = shell.ExpandEnvironmentStrings( value );
				}
			}
		} );
		classLoaded = true;
		resolveExtends();
	}
	
	this.getClass = function( name ){
		if( !classLoaded ){
			this.loadClasses();
		}
		var clazz = profMap[ name ];
		if( !clazz ){
			WScript.echo("G[: NX "+ name +" `Ă܂");
			WScript.quit();
		}
		return clazz;
	}
	
	var resolveExtends = function(){
		for( var key in profMap ){
			var prof = profMap[ key ];
			new function( prof ){
				if( prof.base && ! prof.resolved ){
					arguments.callee( profMap[ prof.base ] );
					var base = CluCoreObject.getClass( prof.base );
					new function( profEntry, baseEntry ){
						for( var k in baseEntry ){
							if( profEntry[ k ] == undefined ){
								profEntry[ k ] = baseEntry[ k ];
								continue;
							}
							arguments.callee( profEntry[ k ], baseEntry[ k ] );
						}
					}( prof, base );
					prof.resolved = true;
				}
			}( prof );
		}
	}
	
	this.defineClass = function( name, clazz ){
	}
	
	this.createCommand = function(){
		return new Command();
	}
	
}();

function Command(){
	this.properties = new Object();
}
Command.prototype = {
	name : null,
	path : null,
	icon : null,
	dir : null,
	property : function( app, name, value ){
		if( this.properties[ app ] == undefined ){
			this.properties[ app ] = new Object();
		}
		if( value != undefined ){
			this.properties[ app ][ name ] = value;
		}
		return this.properties[ app ][ name ];
	}
}

function verifyProperty( obj, path, nohalt ){
	var frags = path.split(/\./g);
	var box = obj;
	for( var i = 0; i < frags.length; i++ ){
		if( box[ frags[i] ] == undefined ){
			if( ! nohalt ){
				WScript.Echo("NX̃vpeB "+ frags.slice( 0, i + 1 ).join(".") +" `Ă܂");
				WScript.Quit();
			}else{
				return false;
			}
		}
		box = box[ frags[i] ];
	}
	if( nohalt ){
		return true;
	}
}

function hasProperty( obj, path ){
	return verifyProperty( obj, path, true );
}

function loadPatterns( path ){
	var pos = new Array();
	var neg = new Array();
	read_lines( path, function( line ){
		if( ! line.match(/^\s*;/) && line.length > 0 ){
			if( line.match(/^-(.*)/) ){
				neg.push( RegExp.$1 );
			}else{
				pos.push( line );
			}
		}
	} );
	return [ pos, neg ];
}

function matchPattern( str, pattern ){
	if( pattern.match(/^\s*\"(.*)\"\s*$/i) ){
		return str.toLowerCase().indexOf( RegExp.$1.toLowerCase() ) != -1;
		
	}else if( pattern.match(/^\s*\/(.*)\/\s*$/i) ){
		var regex = new RegExp( RegExp.$1 );
		return str.match( regex );
		
	}else{
		var regex = wc2regex( pattern );
		return str.match( regex );
	}
}

function removeBackslash( path ){
	return path.replace(/\\+$/,"");
}

function Duplicator( id ){
	var doc = new ActiveXObject("MSXML.DOMDocument");
	doc.load( FILE_BOOT_STRAP );
	var jobCurrent = doc.selectSingleNode(
		"/package/job[@id='"+ id +"']");
	foreach( doc.selectNodes("/package/job"), function( node ){
		doc.documentElement.removeChild( node );
	} );
	doc.documentElement.appendChild( jobCurrent );
	
	this.resolveInclude = function(){
		var docInc = new ActiveXObject("MSXML.DOMDocument");
		docInc.load("include.xml");
		var before = jobCurrent.firstChild;
		foreach( docInc.selectNodes("/*/*"), function( node ){
			jobCurrent.insertBefore( node, before );
			before = node.nextSibling;
		} );
	}
	this.instantiate = function( name ){
		var temp = name +".wsf";
		doc.save( temp );
		
		return temp;
	}
}
