
function foreach( c, functor ){
	if( c instanceof Array ){
		for( var i in c ){
			functor( c[i] );
		}
	}else{
		var e = new Enumerator( c );
		for( e.moveFirst(); !e.atEnd(); e.moveNext() ){
			functor( e.item() );
		}
	}
}

function find_if( c, functor ){
	if( c instanceof Array ){
		for( var i in c ){
			if( functor( c[i] ) ){
				return c[i];
			}
		}
	}else{
		var e = new Enumerator( c );
		for( e.moveFirst(); !e.atEnd(); e.moveNext() ){
			if( functor( e.item() ) ){
				return e.item();
			}
		}
	}
	return null;
}

function enumFile( path, fileFunctor, dirFunctor ){
	if( ! dirFunctor ){
		dirFunctor = arguments.callee;
	}
	var f = fso.GetFolder( shell.ExpandEnvironmentStrings( path ) );
	foreach( f.Files, fileFunctor );
	foreach( f.SubFolders, function( item ){
			dirFunctor( item.Path, fileFunctor, dirFunctor );
		} );
}

function wc2regex( str ){
	str = str.replace(/([!-\/:-@\[-`{-~])/g,"\\$1");
	str = str.replace(/\\\*/g,".*");
	str = str.replace(/\\\?/g,".?");
	return new RegExp("^"+ str +"$","i");
}

function findFile( path, ext, fileFunctor, dirFunctor ){
	if( !( ext instanceof RegExp ) ){	// ext ɂ̓ChJ[hAK\ƂɎgp
		ext = wc2regex( ext );
	}
	enumFile( path, function( file ){
		if( file.Name.match( ext ) ){
			fileFunctor( file );
		}
	}, dirFunctor );
}

function read_lines( path, functor ){
	var ts;
	try{
		ts = fso.OpenTextFile( shell.ExpandEnvironmentStrings( path ) );
	}catch( ex ){
		WScript.Echo("File load error: "+ path +"\nCall: "+ arguments.caller );
		WScript.Quit();
	}
	while( ! ts.AtEndOfStream ){
		functor( ts.ReadLine() );
	}
	ts.Close();
}

function equal_to( cp1, cp2 ){
	return cp1 == cp2;
}
