
function toBWPath( path ){
	path = path.replace(/\\/g,"\\\\");
	path = path.replace(/\s/g,"\\s");
	return path;
}

function decodeBWPath( path ){
	path = path.replace(/\\\\/g,"\\");
	path = path.replace(/\\s/g," ");
	return path;
}

var propMap = [
	"Type","IIndex"
];

function loadProperty( cmd, name, line ){
	var regex = new RegExp("\\t"+ name +"=([^\\s]+)");
	return cmd.property("bluewind", name, ( line.match( regex ), RegExp.$1 ) );
}
function serializeProperty( cmd, name, def ){
	return ( cmd.property("bluewind", name ) != undefined ) ?
		name +"="+ cmd.property("bluewind", name ) : name +"="+ def;
}

CluCoreObject.addLauncherTraits("bluewind", {
	loadCommandList : function( clazz, cmdlist ){
		read_lines( fso.BuildPath( clazz.path.profile, "%.wind"), function( line ){
			var cmd = new Command();
			cmd.name = ( line.match(/^([^\s]+)/), RegExp.$1 );
			cmd.path = ( line.match(/\tCommand=([^\s]+)/), decodeBWPath( RegExp.$1 ) );
			cmd.dir = ( line.match(/\tDir=([^\s]+)/), RegExp.$1 );
			foreach( propMap, function( name ){
				loadProperty( cmd, name, line );
			} );
			cmdlist.push( cmd );
		} );
	},
	saveCommandList : function( clazz, cmdlist ){
		var tab = "\t";
		var os = fso.OpenTextFile( fso.BuildPath( clazz.path.profile, "%.wind"), ForWriting, true );
		foreach( cmdlist, function( cmd ){
			var path = toBWPath( cmd.path );
			var line = cmd.name + tab
				+"Command="+ path + tab
				+"Icon="+ path + tab
				+"Dir="+ path;
			foreach( propMap, function( name ){
				line += tab + serializeProperty( cmd, name, "0");
			} );
			os.WriteLine( line );
		} );
		os.Close();
	}
} );
