
CluCoreObject.addLauncherTraits("wfxml", {
	loadCommandList : function( clazz, cmdlist ){
		if( ! cmdlist ){
			cmdlist = new Array();
		}
		var doc = new ActiveXObject("MSXML.DOMDocument");
		verifyProperty( clazz, "xml.path");
		if( ! fso.FileExists( clazz.xml.path ) ){
			return;
		}
		if( ! doc.load( clazz.xml.path ) ){
			WScript.Echo("LXMLt@Cł͂܂");
			WScript.Quit();
		}
		foreach( doc.documentElement.selectNodes("/profile/command"), function( command ){
			var cmd = new Command();
			cmd.name = command.selectSingleNode("@name").nodeValue;
			var path = command.selectSingleNode("path/text()");
			cmd.path = path ? path.nodeValue : "";
			foreach( command.getElementsByTagName("property"), function( node ){
				if( node.firstChild ){
					cmd.property( node.getAttribute("for"), node.getAttribute("name"), node.firstChild.nodeValue );
				}
			} );
			cmdlist.push( cmd );
		} );
		
		return cmdlist;
	},
	saveCommandList : function( clazz, cmdlist ){
		var doc = new ActiveXObject("MSXML.DOMDocument");
		doc.appendChild( doc.createProcessingInstruction("xml","version='1.0' encoding='utf-8'") );
		var root = doc.createElement("profile");
		doc.appendChild( root );
		foreach( cmdlist, function( cmd ){
			root.appendChild( doc.createTextNode("\n\t") );
			var command = doc.createElement("command");
			command.setAttribute("name", cmd.name );
			root.appendChild( command );
			var path = doc.createElement("path");
			path.appendChild( doc.createTextNode( cmd.path ) );
			command.appendChild( doc.createTextNode("\n\t\t") );
			command.appendChild( path );
			for( var app in cmd.properties ){
				for( var key in cmd.properties[ app ] ){
					var prop = doc.createElement("property");
					prop.setAttribute("for", app );
					prop.setAttribute("name", key );
					var text = doc.createTextNode( cmd.property( app, key ) );
					prop.appendChild( text );
					command.appendChild( doc.createTextNode("\n\t\t") );
					command.appendChild( prop );
				}
			}
			command.appendChild( doc.createTextNode("\n\t") );
		} );
		root.appendChild( doc.createTextNode("\n") );
		verifyProperty( clazz, "xml.path");
		doc.save( clazz.xml.path );
	}
} );
